/*
PROJETO: Game OPENGL "Batalha Naval"
Author	: Roger Larico Chavez
RA		: 022693

  FEEC UNICAMP
*/
GLfloat mat_ambient_diffuse [] = {0.0,0.8,1.0,1.0};
GLfloat mat_specular []		= {0.7,0.0,0.0,1.0};
GLfloat mat_emission []		= {0.0,0.0,0.0,1.0};
GLfloat mat_shininess		= 0.2;

GLfloat spot_dir [] = {0.0,0.0,-1.0};

GLfloat focus_emission [] = {0.8,0.8,0.8,1.0};

float random(float ini, float end)
{
	float rnd,r2;
	r2=rand();
	rnd=abs((end-ini)*r2/(RAND_MAX)+ini);	
	return (rnd);
}

void DisplayListTable(int size,float sizeItemTable)
{
	float isc=size*sizeItemTable/2;
	glNewList(Table.list , GL_COMPILE);
		/*PLANO DE TEXTURA DA AGUA*/
		/*glPushMatrix();		  
		  glTranslatef(0,0,-1);
		  glColor3f(0,0.45,1);
		glBegin(GL_QUADS);			
			glVertex3f(isc,-isc,0);			
			glVertex3f(isc,isc,0);
			glVertex3f(-isc,isc,0);	
			glVertex3f(-isc,-isc,0);			
		glEnd();
		glColor3f(1,1,1);  
		glPopMatrix();
		/**/

		glColor3f(0.73,0.74,1);			  
		glPushMatrix();		
			glScalef(1,1,0.01);
			glTranslatef(0,0,-24);
			glutSolidCube(N*sizeItemTable);
		glPopMatrix();
		glColor3f(1,1,1);			  
		
		
		/*RETICULADO items*/
		glBegin(GL_LINES);
		for(int i=-size/2;i<=size/2;i++)
		{
			glVertex3f(i*sizeItemTable,-isc,0);
			glVertex3f(i*sizeItemTable, isc,0);	
			glVertex3f(-isc,i*sizeItemTable,0);
			glVertex3f(	isc,i*sizeItemTable,0);	
		}

		glEnd();		
		/**/		
	glEndList();
}
 
void DisplayListNaveA()
{	
  GLUquadricObj* q;
  glNewList(NaveA.large-1 , GL_COMPILE);
  q = gluNewQuadric();

glPushMatrix();
	glDepthFunc(GL_LEQUAL);
	glEnable(GL_DEPTH_TEST);
	glClearDepth(1.0);
	glTranslatef(0,5,1);
	glRotatef(90, 1, 0, 0);  
	//glColor3f(0.70,0.6,0.72);
	glPushMatrix();
		
 	glBegin(GL_TRIANGLES);			
			glVertex3f(15,	-2.2,	7.5);
			glVertex3f(23,	2.8,	0);	
			glVertex3f(15,	2.8,	7.5);
			
			glVertex3f(15,	2.8,	-7.5);					
			glVertex3f(23,	2.8,	0);	
			glVertex3f(15,	-2.2,	-7.5);

			glVertex3f(15,	2.8,	7.5);				
			glVertex3f(23,	2.8,	0);	
			glVertex3f(15,	2.8,	-7.5);
			/**/
			glVertex3f(23,	2.8,	0);	
			glVertex3f(15,	-2.2,	7.5);
			glVertex3f(15,	-2.2,	-7.5);					
	glEnd();
  glPopMatrix();

  /**/ 
  //glColor3f(0.70,0.6,0.72);
  glPushMatrix();
  glTranslatef(-5,15,0);
	glBegin(GL_LINES);
		glVertex3f(0,	-5,	0);		
		glVertex3f(0,	0,	0);		
	glEnd();

  float rnd1=random(0,90);
  glRotatef(rnd1, 0, 1, 0);
  gluCylinder(q,0.1,3,2,8,8);
  glPopMatrix();
/**/
  //glColor3f(0,0,1);
  glPushMatrix();
  glTranslatef(-8.3,8.5,4);
  glRotatef(90, 0, 1, 0);
  gluCylinder(q,1,1.3,2,8,8);  
  glRotatef(180, 0, 1, 0);
  gluCylinder(q,1,1.3,2,8,8);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(-8.3,8.5,-4);
  glRotatef(90, 0, 1, 0);
  gluCylinder(q,1,1.3,2,8,8);
  glRotatef(180, 0, 1, 0);
  gluCylinder(q,1,1.3,2,8,8);
  glPopMatrix();
/**/
  //glColor3f(0.50,0.6,0.52);  
  glPushMatrix();
  glScalef(6,1,3);
  glTranslatef(0,0.35,0);
  glutSolidCube(5);
  glPopMatrix();
 

/**/
  //glColor3f(0,0.2,0.1);
  glPushMatrix();
  glScalef(4,0.5,3);
  glTranslatef(-1,8.35,0);
  glutSolidCube(5);
  glPopMatrix();

/**/
  
  glColorMaterial(GL_FRONT,GL_EMISSION);
  glEnable(GL_COLOR_MATERIAL);
  glColor4fv(focus_emission);
  

  glPushMatrix();
  glScalef(1,1,1);
  glTranslatef(-6,8.15,0);
  glutSolidCube(5);
  glPopMatrix();
  glColor3f(1,1,1);
  
  glColor4fv(mat_emission);
  glDisable(GL_COLOR_MATERIAL);

glPopMatrix();
  gluDeleteQuadric(q);
  glEndList();
}

void DisplayListNaveB()
{
  GLUquadricObj* q;
  glNewList(NaveB.large-1, GL_COMPILE);
  q = gluNewQuadric();
  
  glTranslatef(0,15,10);
  glRotatef(90, 1, 0, 0);  

glPushMatrix();
    glDepthFunc(GL_LEQUAL);
	glEnable(GL_DEPTH_TEST);
	glClearDepth(1.0);


  glPushMatrix();
  glScalef(2,1,2);
  glRotatef(-45,0,1,0);
  glTranslatef(7.02,0,0.05);
  glutSolidCube(3);
  glPopMatrix();
/**/
  glPushMatrix();
  glScalef(6.8,1,2.77);
  glTranslatef(-0.01,0,3.62);
  glutSolidCube(3);
  glPopMatrix();
/**/
  glPushMatrix();
  glScalef(2,1,2);
  glTranslatef(1,3,5);
  glRotatef(-45,0,1,0);  
  glutSolidCube(3);
  glPopMatrix();
  /**/
  glPushMatrix();
  glTranslatef(-4,6,10);
  glScalef(0.15,0.15,0.15);
  glRotatef(-90, 1, 0, 0);
  glCallList(7);  //tower
  glPopMatrix();

  glPushMatrix();
  glScalef(3.8,1,2.77);
  glTranslatef(-1,3,3.62);
  glutSolidCube(3);
  glPopMatrix();
  /**/
  glPushMatrix();
  glScalef(3.8,1,2.77);
  glTranslatef(-1,5.8,3.62);
  glutSolidCube(2);
  glPopMatrix();

  /**/
 glPushMatrix();
 glTranslatef(4,3,8);
 glRotatef(90, 0, 1, 0);
 gluCylinder(q,0.5,0.5,2.5,20,10);
 glPopMatrix();
  /**/
 glPushMatrix();
 glTranslatef(4,3,12);
 glRotatef(90, 0, 1, 0);
 gluCylinder(q,0.5,0.5,2.5,20,10);
 glPopMatrix();
/**/
/**///janela lampada 
 glPushMatrix();
 glColorMaterial(GL_FRONT,GL_EMISSION);
 glEnable(GL_COLOR_MATERIAL);
 glColor4fv(focus_emission);
 glTranslatef(0,6,10);
 glRotatef(90, 0, 1, 0);
 glTranslatef(-1.5,0,0);
 glutSolidCube(1);
 glTranslatef(1.5,0,0);
 glutSolidCube(1);
 glTranslatef(1.5,0,0);
 glutSolidCube(1);
 glColor4fv(mat_emission);
 glDisable(GL_COLOR_MATERIAL);

  glPopMatrix();
 
 glDisable(GL_DEPTH_TEST);
glPopMatrix();
  gluDeleteQuadric(q);
  glEndList();
}

void DisplayTower(void)
{

/**/
  GLUquadricObj* q;
  glNewList(7, GL_COMPILE);
  q = gluNewQuadric();
  glPushMatrix();

		glDepthFunc(GL_LEQUAL);
		glEnable(GL_DEPTH_TEST);
		glClearDepth(1.0);
			 //glColor3f(0,1,0);
		  glPushMatrix();
			  gluCylinder(q, 3, 0.5, 20, 12, 3);			  
		  glPopMatrix();
		  glPushMatrix();
			glRotatef(90, 1, 0, 0);
			glTranslatef(0,20,0);
			gluCylinder(q,0.1,10,5,8,8);
		  glPopMatrix();
		    glColorMaterial(GL_FRONT,GL_EMISSION);
			glEnable(GL_COLOR_MATERIAL);
			glColor4fv(focus_emission);

		  glPushMatrix();
			glTranslatef(0,-5,20);
			glRotatef(90, 1, 0, 0);
			gluCylinder(q,10,0.1,0.1,8,8);
		  glPopMatrix();
		  
		  glColor4fv(mat_emission);
		  glDisable(GL_COLOR_MATERIAL);

  glPopMatrix();
  gluDeleteQuadric(q);
  glEndList();
	
/**/		
}

void DisplayListNaveC()
{
	int i;
	GLUquadricObj* q;
	glNewList(NaveC.large-1, GL_COMPILE);
	q = gluNewQuadric();
	glTranslatef(0,15,10);
	glRotatef(90, 1, 0, 0);  
		
	glPushMatrix();
		glDepthFunc(GL_LEQUAL);
		glEnable(GL_DEPTH_TEST);
		glClearDepth(1.0);

		/**/
		glPushMatrix();
		glScalef(2,1,2);
		glRotatef(45,0,1,0);
		glTranslatef(-7,0,0);
		glutSolidCube(3);
		glPopMatrix();

		/**/
		glPushMatrix();
		glScalef(2,1,2);
		glRotatef(-45,0,1,0);
		glTranslatef(7,0,0);
		glutSolidCube(3);
		glPopMatrix();
		/**/

		glPushMatrix();
			glTranslatef(0,2.2,12.5);
			glScalef(0.4,0.4,0.4);
			glRotatef(135, 0, 1, 0);  
			glCallList(6);  //Jet
			glTranslatef(-5,0,5);
			glCallList(6);  //Jet
			glTranslatef(-5,0,5);
			glCallList(6);  //Jet
			glTranslatef(-5,0,5);
			glCallList(6);  //Jet
			glTranslatef(-5,0,5);
			glCallList(6);  //Jet
			glTranslatef(-5,0,5);
			glCallList(6);  //Jet
		glPopMatrix();

		glPushMatrix();
			glTranslatef(-10,4,12);
			glScalef(0.1,0.1,0.1);
			glRotatef(-90, 1, 0, 0);
			glCallList(7);  //tower
		glPopMatrix();

		glPushMatrix();
			glTranslatef(-12,4,10);
			glScalef(0.05,0.05,0.05);
			glRotatef(-90, 1, 0, 0);
			glRotatef(-90, 0, 0, 1);
			glCallList(7);  //tower
		glPopMatrix();

		glPushMatrix();
			glTranslatef(-8,4,10);
			glScalef(0.07,0.07,0.07);
			glRotatef(-90, 1, 0, 0);
			glRotatef(+90, 0, 0, 1);
			glCallList(7);  //tower
		glPopMatrix();

		glPushMatrix();
			glTranslatef(19,3,8);
			glScalef(0.4,0.4,0.4);
			glRotatef(90, 0, 1, 0);  
			glRotatef(-25, 1, 0, 0);  
			glCallList(6);  //Jet
		glPopMatrix();

		/**/
		glPushMatrix();
		glScalef(6.6,1,2.76);
		glTranslatef(0,0,3.62);
		glutSolidCube(3);
		glPopMatrix();
		
		/*luz pista: centro*/
		glPushMatrix();
		glScalef(0.5,0.2,0.2);
		glTranslatef(-11,9,40);


		for(i=0;i<16;i++)
		{
			glColorMaterial(GL_FRONT,GL_EMISSION);
			glEnable(GL_COLOR_MATERIAL);
			glColor4fv(focus_emission);

			glTranslatef(3,0,0);
			glutSolidCube(2);			
		}	
		glPopMatrix();
		/**/

		/*luz pista: lados*/
		glPushMatrix();	
		glTranslatef(-5,2,10);
		for(i=0;i<24;i++)
		{
			glTranslatef(1,0,0);
			glutSolidSphere(0.3,3,3);
			glPushMatrix();	
				glTranslatef(0,0,-4);
				glutSolidSphere(0.3,3,3);
			glPopMatrix();

		}	
		glPopMatrix();
		/**/
		glColor4fv(mat_emission);
		glDisable(GL_COLOR_MATERIAL);

		/*pista de avioes*/
		glPushMatrix();
		glScalef(11,0.2,2.76);
		glTranslatef(0,8,3.62);
		glutSolidCube(3);
		glPopMatrix();

		glPushMatrix();
		glScalef(11,0.2,1.76);
		glTranslatef(0.3,8,4.62);
		glutSolidCube(3);
		glPopMatrix();

		/**/
		glPushMatrix();
		glScalef(9.6,2,5.76);
		glTranslatef(-1,1.5,1.8);
		glutSolidCube(1);
		glPopMatrix();
		/**/

		glDisable(GL_DEPTH_TEST);
	glPopMatrix();	
	gluDeleteQuadric(q);
	glEndList();
}


void DisplayListJet(void)
{
	GLint jetid=6;/*id do Jet*/
	GLUquadricObj *q;
	GLfloat asa[][3]={{-4.0,0.0,0.0},{+4.0,0.0,0.0},{0.0,0.0,3.0}};
	GLfloat cauda[][3]={{0.0,0.0,0.0},{0.0,2.0,-1.0},{0.0,2.0,0.0},{0.0,0.0,2.0}};
  /* inicia a composicao do JET */
	glNewList(jetid, GL_COMPILE);		
	glPushMatrix ( );		
		glDepthFunc(GL_LEQUAL);
		glEnable(GL_DEPTH_TEST);
		glClearDepth(1.0);
		glColorMaterial(GL_FRONT,GL_EMISSION);
			glEnable(GL_COLOR_MATERIAL);
			glColor4fv(focus_emission);
			
			q = gluNewQuadric();  
			glPushMatrix();
				glTranslatef(2,0,0);
				gluCylinder(q, 0.3, 0.1, 1.5, 12, 3);
				glTranslatef(-4,0,0);
				gluCylinder(q, 0.3, 0.1, 1.5, 12, 3);
			glPopMatrix();
			
			glColor4fv(mat_emission);
			glDisable(GL_COLOR_MATERIAL);
		/* asas */
		glBegin(GL_TRIANGLES); /*ambas caras*/
			glVertex3fv(asa[0]);
			glVertex3fv(asa[1]);
			glVertex3fv(asa[2]);
			glVertex3fv(asa[2]);
			glVertex3fv(asa[1]);
			glVertex3fv(asa[0]);
		glEnd();

			

		/* corpo */
		q = gluNewQuadric();  
		gluCylinder(q, 0.5, 0.5, 4, 12, 3);
		/* nariz */
		
		q = gluNewQuadric();
		glPushMatrix();
		glTranslatef(0,0,4);
		gluCylinder(q, 0.5, 0.0, 1.5, 12, 3);
		glPopMatrix();
		/* cauda */		
		glBegin(GL_POLYGON); 
			glVertex3fv(cauda[0]);
			glVertex3fv(cauda[1]);
			glVertex3fv(cauda[2]);
			glVertex3fv(cauda[3]);
		glEnd();
		glBegin(GL_POLYGON); 
			glVertex3fv(cauda[3]);
			glVertex3fv(cauda[2]);
			glVertex3fv(cauda[1]);
			glVertex3fv(cauda[0]);
		glEnd();
		/* cabine do piloto */	  
		glTranslatef(0,0.3,3.5);
		glPushMatrix();
			
			glColorMaterial(GL_FRONT,GL_EMISSION);
			glEnable(GL_COLOR_MATERIAL);
			glColor4fv(focus_emission);
	

			glScalef(0.7,0.7,2.0);
			q=gluNewQuadric();
			//glColor3f(0.3,0.5,1);
			gluSphere(q,0.5,12,12);
			
			glColor4fv(mat_emission);
			glDisable(GL_COLOR_MATERIAL);

		glPopMatrix();
	glPopMatrix();
  glEndList();
}

void DisplayListGlobe( void )
{	
  GLUquadricObj* q;
  glNewList(5 , GL_COMPILE);
  q = gluNewQuadric();
  glPushMatrix ( );
	glDepthFunc(GL_LEQUAL);
	glEnable(GL_DEPTH_TEST);
	glClearDepth(1.0);
  glPushMatrix ( );
   glRotatef ( 90.0, 1.0, 0.0, 0.0 );   
   gluQuadricNormals ( q, GLU_SMOOTH );   
   gluSphere ( q, 6.0, 20, 20 );
  glPopMatrix ( );  
  /*
  glPushMatrix();
	glScalef(11,0.2,2.76);
	glTranslatef(0,10,3.62);
	glutSolidCube(3);
  glPopMatrix();
  /**/
  glPopMatrix();
  gluDeleteQuadric(q);
  glEndList();   
}

